//
// Created by zx on 2020/7/10.
//

//
// Created by zx on 2020/7/3.
//
#include <unistd.h>
#include <iostream>
#include <nnxx/message>
#include <nnxx/socket.h>
#include <nnxx/bus.h>

#include "terminal_message.pb.h"
#include <thread>
#include "threadSafeQueue.h"

std::mutex lock;

threadsafe_queue<std::string> license_queue;
#include "Terminal_communication.h"

void pickup()
{
    message::Base_info base_msg;
    message::Pickup_command_request_msg request;

    base_msg.set_msg_type(message::ePickup_command_request_msg);
    base_msg.set_sender(message::eTerminor);
    base_msg.set_receiver(message::eMain);
    request.mutable_base_info()->CopyFrom(base_msg);

    int command_id = rand() % 900000 + 100000;
    char license[255] = {0};
    sprintf(license, "鄂A%d", command_id);

    request.set_terminal_id(command_id % 6);
    message::Car_info car_info;
    car_info.set_license(license);
    car_info.set_car_height(1.5);
    car_info.set_car_width(1.7);
    request.mutable_car_info()->CopyFrom(car_info);

    message::Pickup_command_response_msg response;
    Error_manager code=Terminal_communication::get_instance_pointer()->pickup_request(request,response);
    if(code!=SUCCESS)
    {
        std::cout<<code.to_string()<<std::endl;
    }
    else
    {
        if(response.code().error_code()!=0)
        {
            std::cout<<response.code().error_description()<<std::endl;
        }
    }

}

int main() {
    Terminal_communication::get_instance_pointer()->communication_connect("tcp://127.0.0.1:9001");
    Terminal_communication::get_instance_pointer()->communication_run();

    int n = 0;
    bool run = true;
    Error_manager code;
    //std::thread* pth=new std::thread(cancel_thread);
    while (run) {
        pickup();
        /*message::Base_info base_msg;
        message::Store_command_request_msg request;

        base_msg.set_msg_type(message::eStore_command_request_msg);
        base_msg.set_sender(message::eTerminor);
        base_msg.set_receiver(message::eMain);
        request.mutable_base_info()->CopyFrom(base_msg);

        int command_id = rand() % 900000 + 100000;
        char license[255] = {0};
        sprintf(license, "鄂A%d", command_id);

        request.set_terminal_id(command_id % 6);
        message::Car_info car_info;
        car_info.set_license(license);
        car_info.set_car_height(1.5);
        car_info.set_car_width(1.7);
        request.mutable_car_info()->CopyFrom(car_info);
        message::Locate_information locate_info;
        locate_info.set_locate_x(0.9);
        locate_info.set_locate_y(2.25);
        locate_info.set_locate_angle(90.0);
        locate_info.set_locate_wheel_base(2.7);
        locate_info.set_locate_width(1.7);
        locate_info.set_locate_height(1.5);
        locate_info.set_locate_correct(true);
        request.mutable_locate_information()->CopyFrom(locate_info);

        message::Store_command_response_msg response;
        code=Terminal_communication::get_instance_pointer()->store_request(request,response);
        if(code!=SUCCESS)
        {
            std::cout<<code.to_string()<<std::endl;
        }
        else
        {
            printf("N:%08d\n",n++);
        }*/
        //每两秒发送一次
        usleep(1000*1000);
        std::this_thread::yield();
    }
}

